/* de esta forma podemos importar nuestras fonts web, y usarlas globalmente
ya que si la importamos de la forma de html, tendriamos que importar en cada archivo donde la vayamos a usar
esta forma es mejor y nos ayuda a centralizar todos nuestros archivos en uno solo para su importación */
/* @import url('https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,400;0,900;1,100&display=swap'); */
@import url('https://fonts.googleapis.com/css2?family=Roboto:wght@100;400;900&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@500&display=swap');

/* en css podemos hacer uso de variables, las variables nos ayudan a asignar valores con un nombre especifico, que luego 
podemos reutilizar en varios lados donde vayamos a usar el mismo valor, y que además queremos que se mantenga siempre el mismo
valor en todos esos lados aún cuando cambiemos el valor de la variable */
/* para definir las variables lo recomendable es definirlas usando el pseudoelemento :root,
este elemento tiene mayor especificidad que el elemento html y nos ayuda a que todo lo que definamos dentro de él
lo podamos usar en cualquier otro selector de nuestro proyecto */
:root {
	/* para definir los nombres y valores de las variables, primero definimos las variables,
	escribiendo dos guiones, seguido del nombre de la variable, despues le asignamos el valor que queremos
	que tenga, el valor puede ser númerico, un color, una medida, entre muchos otros, en este caso
	vamos a asignar dos colores a dos variables como se puede ver a continuación */
	--dark-green: #220e4f;
	--highlight-color: #ff1b68;
}

* {
	/* una estrategia que podemos seguir al desarrollar nuestra página web, es la de resetear el css, resetear el css
	se usa principalmente debido a que los navegadores inyectan cada uno una serie de estilos por defecto que alteran los elementos
	html, por ejemplo un padding y margin por defecto a etiquetas h1, a divs, a titles */
	/* estos estilos por defecto de cada navegador puede hacer que nuestra página tenga incosistencias al verse en diferentes
	navegadores, una forma de resolver estos problemas es reseteando el css para que la página se vea siempre igual no importa
	el navegador donde se muestre, hay librerias que se encargan de hacer eso
	declarando estilos por defecto que se usaran para cada elemento html, un ejemplo es normalize.css, o tambien podemos
	seguir otra estrategia donde modifiquemos los estilos de manera global, por ejemplo aquí estamos usando el selector global
	para asignar el box-sizing de borderbox a todos los elementos, ya que no tendríá muchas veces sentido instalar una libreria 
	para resetear el css si puede que nuestra página no ocupe muchos de los elementos que se están reseteando, y solo estariamos cargando
	archivos adicionales que aumentarían el tamaño de nuestro bundle */
	/* se debe validar cual es la mejor alternativa que se quiera seguir para resetear el css en caso de ser necesario, validando siempre
	el desempeño optimo de nuestra página */
	box-sizing: border-box;
}

html {
	/* height: 100%; */
	/* si asignamos en html el tamaño de fuente y la ponemos como porcentaje
	este porcentaje hará referencia al tamaño por defecto de la fuente en el navegador,
	entonces al asignar 75% se reducirá el tamaño al 75% del tamaño por defecto del navegador
	que será lo que se tomará como el 100%, este uso no se hará a menudo ya que normalmente
	para fuentes se usarán ems y rems */
	/* font-size: 75%; */
	height: 100%;
}

/* vamos a agregar una nueva propiedad a nuestro css, es la propiedad supports, esta es una validación que podemos agregar
para verificar que alguna propiedad de css que queremos usar, sea compatible con el navegador que estamos usando para renderizar
la página, y por ende se muestre correctamente, vamos a declarar dos veces la etiqueta body, una aqui como se ve abajo, sin los
atributos que son dependeintes del grid, y dentro de supports declaramos los que sí son dependientes del grid */
body {
	font-family: 'Montserrat', 'Arial', sans-serif !important;
	margin: 0;
	/* asignamos un padding top al body para que deje un espacio en la parte superior antes de empezar a pintar contenido,
	porque recordemos que en la parte superior tenemos nuestro navbar, y si no tenemos el grid, va a posicionarse encima
	de nuestro contenido principal, con el grid este header se posicionaba en el primer renglon y el contenido en el segundo
	renglon, por tanto no era necesario agregar paddings */
	padding-top: 3.5rem;
}

/* podemos agregar varias opciones en supports, como lo hacemos usando los media queries usando and, not y or */
/* @supports (display: grid) and not ()  { */
/* vamos a validar que el navegador donde se muestre este código, sea compatible con el display grid, usando supports y enviando
como parámetro, el valor que queremos validar,que en este caso como se menciona es display: grid, dentro de él tenemos código que depende
de que grid sea compatible con el código, aqui en supports el atributo y el valor del atributo son validados así que debemos enviar ambos
osae tal cual enviamos display:grid y no solo display o grid */
@supports (display: grid) {
	body {
		/* con el atributo font-family, definimos la fuente a usar, se tomará la primera de la lista
	que esté disponible, por ejemplo en este caso definimos la fuente Montserrat que se tomará
	si está disponible, si no está nos vamos a la siguiente que es Arial, y si tampoco está disponible
	lo mejor es agregar una familia genérica, en este caso se agregará la fuente sans-serif que esté
	definida por el usuario en las configuraciones del navegador
	una nota esque poner las comillas al rededor del nombre de la fuente no es obligatorio, se debe colocar
	solo cuando el nombre de la fuente lleva espacios por ejemplo 'Times New Roman' */
		/* font-family: 'Montserrat', 'Arial', sans-serif !important; */

		/* margin: 0; */
		/* height: 100%; */
		/* Vamos a cambiar la forma en que ajustamos nuestro footer a la parte inferior de nuestra página
	para ello usaremos un grid con 3 renglones, el primer renglón tendrá la altura de nuestro header, al ser nuestro
	header position fixed, no se posicionará sobre nuestro grid y en vez de eso nuestro elemento main ocupará esa posicion y el footer
	ocupará la segunda posicion pero eso se soluciona indicando a nuestros elementos la posición del grid 
	que usarán */
		display: grid;
		/* creamos nuestros 3 renglones, el primero de 3.5 de alto que es para el header
	el segundo es el contenido main, y tendrá una altura automática porque será dependiendo de su contenido, y por último
	nuestro footer tendrá una altura de 8rem */
		/* vamos a cambiar el ultimo valor de nuestro tercer renglón, esto es porque no debemos dejarlo fijo en 8rem
	ya que en dispositivos móviles el contenido en ese renglón pasa de horizontal a vertical por lo que necesita más espacio
	más allá de los 8rem que asignamos, si lo dejamos fijo en 8 rem el contenido se va a desbordar y no será visible, asignarlo
	de forma auto tampoco nos ayudará mucho ya que el renglón creceria demasiado porque el espacio disponible se
	repartiría entre los 2 elementos con valor auto
	en vez de eso usamos la funcion fit-content que recibe un argumento que es el tamaño mínimo que tendrá el elemento, en caso de ser
	necesario el elemento crecerá para ajustar su contenido y que nada se desborde, lo que nos da mayor dinamismo al asignar un valor y 
	hace que podamos tener todo el contenido visible, el contenido solo crecera de ser necesario, en cualquier otro caso
	se mantendrá en el valor que asignemos dentro de la función, en este caso 8rem que es el tamaño que queremos tenga nuestro
	footer */
		grid-template-rows: 3.5rem auto fit-content(8rem);
		/* padding-top: 3.5rem; */
		/* asignamos una altura de 100% a nuestro body y a nuestro html, esto lo hacemos para que nuestro
	grid pueda usar toda la altura disponible de nuestra página, sino lo asignamos, el grid solo tendrá la altura 
	necesaria segun el contenido, ya que el segundo renglón es automático */
		height: 100%;
		/* creamos las areas de nuestro grid, esto nos ayuda a nombrar cada celda, en este caso cada renglón ya que solo usaremos
	una columna que por defecto usará todo el ancho disponible */
		grid-template-areas:
			'header'
			'main'
			'footer';
		/* asignamos un padding top de 0, esto para resetear el padding agregado en la etiqueta body de arriba, ya que
ese padding solo debería existir si nuestra página */
		padding-top: 0;
	}
}

main {
	/* min-height: calc(100vh - (3.5rem + 8.1rem)); */
	/* margin-top: 3.5rem; */
	/* grid-row: 2 / 3; */
	/* asignamos nuestro main al area definida main que en este 
	caso es el segundo renglón, se puede asignar usando grid-row
	pero como definimos las áreas al tener solo una columna nos es más fácil así */
	grid-area: main;
}

.backdrop {
	/* si usamos absolute y no tenemos ancestro que contenga una position diferente
	de static, se tomará para el porcentaje el valor del viewport */
	/* position: absolute; */
	/* fixed soluciona el problema pero no nos deja hacer click en nada de atrás porque se posiciona
	encima de todo por eso agregamos un display none, esto deberia modificarse con javascript
	para mostrarse y ocultarse */
	position: fixed;
	/* display: none; */

	/* debemos considerar algo muy importante con las transiciones, y es que no podemos de momento aplicar transition al elemento
	display, y otra consideración más importante, si durante nuestro intento de  transition además de modificar el elemento que queremos
	transicionar, modificamos el valor de display, por ejemplo de block a none o al revés, no se aplicará ninguna transición 
	incluso si los demás atributos que modificamos sí son transicionables*/

	/* por ejemplo con esta configuración tenemos inicialmente un display none con un opacity 0, recordar
	que en nuestra clase open, que se agrega posteriormente a este elemento al hacer click sobre un botón que dispara este backdrop
	y el modal, asignamos el display a block y opacity a 1, opacity funcionaría bien si lo usaramos sin otra transición, el problema
	está en que el elemento al estar aún en el DOM y encima de los elementos de nuestra página, no permite que podamos hacer click sobre 
	el botón que activa el modal, entonces debemos de alguna forma hacer que la animación funcione usando ambos, display y opacity */

	display: none;
	opacity: 0;
	/* transition: opacity 0.2s linear; */
	/* aqui a pesar de estar usando una transición linear y con duración de 2 segundos a una propiedad valida como lo es opacity
	el elemento no se transicionará de forma correcta por el hecho de que también estamos modificando su propiedad display, aún y cuando
	directamente no estamos aplicando la transicióna  display */
	transition: opacity 0.2s linear;

	/* para evitar el problema de margin collapsing usamos estos top y left en 0
	para eliminar los margenes que se puedan estar agregando */
	top: 0;
	left: 0;
	/* cuando tenemos position relative en un elemento como es este caso, y tenemos una altura
	porcentual, si los elementos anteriores no tienen altura definida,como es este caso, la altura será cero.
	en este caso el elemento anterior es directamente body, y body es dinamico en altura, porque su altura
	se basa en el contenido que tenga, por lo tanto no sabe que altura tomar porque en realidad no está definida
	para que esto cubra toda la pantalla, se debe asignar primero a html una altura de 100% y posteriormente a body
	de este modo tendrán alturas definidas y este 100% podrá hacer referencia a dichas alturas y podrá cubrir todo */
	/* position: relative; */
	z-index: 100;
	/* width: 100%;
	height: 100%; */

	/* en vez de usar medidas porcentuales en el backdrop, podemos usar
	medidas de viewport, aqui como estamos usando position fixed no hay diferencia de usar porcentuales a
	medidas viewport ya que para el caso de fixed el porcentaje hace referencia ya al viewport */
	/* pero con estas medidas como su nombre lo indica, vw y vh hacen referencia al tamaño de 
	la parte visible de nuestra página que podemos ver, osea seria el ancho y alto del visor del navegador donde lo 
	estemos viendo, y es un porcentaje de esa medida por lo que 100 seria el total de esa medida */
	width: 100vw;
	height: 100vh;

	/* tenemos ademas otras 2 medidas de viewport que son vmin y vmax
	estas medidas hacen referencia a diferentes cosas
	Vmin: es el mínimo de la altura o anchura del viewport, el que sea minimo entre el vh y vw actual, 
	se tomará como medida para el Vmin, y el valor que le asignemos al vmin será un porcentaje de ese total
	Vmax: contrario a vmin, es el máximo del vh y vw y el valor que le asignemos tambien sera un porcentaje
	de alguno de estos dos */

	/* width: 80vmin; */
	/* width: 80vmax; */
	/* height: 100vh; */

	background: rgba(0, 0, 0, 0.5);
}

.button {
	/* para asignar el valor de una variable dentro de un selector, lo que hacemos es usar la función var, enviando como parámetro
	el valor de la variable que queremos usar, en este caso aquí usaremos la variable dark green, como podemos ver,
	estamos enviando un segundo parámetro, y este parámetro es un fallback, es decir, en caso de que falle la función en obtener
	el valor de la variable, se asignará el valor que esté en la segunda posición del método, con eso nos aseguramos de siempre tener
	un valor por defecto, aunque haya algun problema con la variable */
	background: var(--dark-green, #0e4f1f);
	color: white;
	/* inherit forza a heredar los estilos de la fuente
	aqui los usamos para que no use los estilos por defecto del navegador
	que son los que se pondrian por defecto en los botones */
	font: inherit;
	/* aquí en esta otra asignación, no usamos el fallback, ya que sabemos que la variable existe y que no nos dará problemas
	el implementarla */
	border: 1.5px solid var(--dark-green);
	/* padding: 8px; */
	padding: 0.5rem;
	border-radius: 8px;
	font-weight: bold;
	/* cursor por defecto es default, pero hay muchos tipos */
	cursor: pointer;
}

.button:hover,
.button:active {
	background-color: white;
	color: var(--dark-green);
}

.button:focus {
	/* outline es una propiedad css que deja marcada un boton cuando lo pulsas */
	/* outline: solid red; */
	outline: none;
}

/* definimos el estilo que tendran los elementos con la clase button y el atributo disabled.
estos serán los botones deshabilitados, para ello, vamos a cambiar el cursor al de tipo not-allowed,
ponemos un borde y color de letra gris, y un fondo del botón tambien de color gris, estos valores
sobreescribirán a los del hover y harán que nuestro botón no parezca más un elemento
clickeable */
.button[disabled] {
	cursor: not-allowed;
	border: #a1a1a1;
	background: #ccc;
	color: #a1a1a1;
}

.main-header {
	width: 100%;
	/* si tenemos margenes en el componente padre del elemento al que queremos aplicar la position fixed
	debemos considerar eso, ya que quizás no baste solo con cambiar la posicion sino tambien debamos
	usar las propiedades left, top, right, bottom para darle contexto dde donde colocarse al element
	además de quizás tener que quitar el margen sobreescribiendolo */
	/* cuando tenemos una propiedad con position fixed y tenemos un valor de medida
	que es porcentual, este porcentaje se refiere al viewport y no a algun padre de nuestro elemento
	aqui el 100% hace referencia al viewport siempre que position sea fixed, de lo contrario
	hará referencia al contenedor del elemento que tenga la clase */
	position: fixed;
	top: 0;
	background: #2ddf5c;
	/* padding: 8px 16px; */
	padding: 0.5rem 1rem;
	z-index: 60;

	/* Vamos a usar flexbox para centrar y distribuir el contenido de nuestro navbar,
	alineamos verticalmente al centro y distribuimos con space-between para tener el primer elemento
	al inicio del container y el segundo al final */

	/* css incluye los llamados vendor prefixes, estos son banderas o prefijos, que se usan para por ejemplo
	añadir propiedades experimentales, antes por ejemplo cuando flex no era un estandar, se agregaban estos
	prefijos para poder empezar a usar sus características en las páginas, es hasta que se convirtió un estándar
	ampliamente utilizado, que ya no fue necesario; estos prefijos se agregan porque cada motor de navegadores
	puede tener su propia manera de implementar la propiedad, hasta que no se crea el estándar, esque todas
	las empresas deben de adaptarse a el, tambien puede que un motor de navegador ya este trabajando en una características
	que aún es una sugerencia, mientras que los otros motores aún no, por tanto esa empresa podría
	ya tener su prefijo y esperar que los demás lo hagan o bien puede que esa características nunca
	sea implementada y quede en algo experimental único de ese motor o bien desechado */
	display: -webkit-box;
	display: -ms-flexbox;
	display: -webkit-flex;
	/* se deben usar los vendor prefixes, antes de la propiedad ya estandarizada, para que se tome el estándar y se ignore
lo anterior, en caso de que el navegador y la versión sean compatibles, si no son compatibles con el estándar puede
que sea compatible con la versión experimental, entonces se ignoraría esta última linea al no poder ser interpretada
por el navedaor, la propiedad estandarizada, debe ir siempre al final de las no estándar */
	display: flex;

	align-items: center;
	justify-content: space-between;
}

/* display property */
.main-nav__item {
	/* agregamos la propiedad inlineblock
	hay 4 posibles valores en display, none, que oculta el elemento 
	inline que pone los elementos uno al lado del otro haciendo que solo ocupen el espacio que necesitan,
	sin considerar margenes y padding, block que hace que todos los elementos tomen todo el ancho disponible del contenedor
	y inline-block que es que los elementos se posicionen uno del lado del otro pero permitiendo que se asignen valores
	a margenes y paddings y anchos
	*/

	/* nuestros items ya no serán inlineblock porque ahora su contenedor será un flex
	que será el que ajustará estos elementos uno al lado del otro */
	/* display: inline-block; */

	/* podemos agregar solo un cero para que debajo y encima no haya margen, solo 
	izquierda y derecha*/
	margin: 0 16px;
	/* no funciona el text decoration aquí porque por defecto por el browser tiene
	decoration underline, tendriamos que aumentar la especificidad para sobreescribir ese valor */
	/* text-decoration: none; */
}

.main-nav__item a,
.mobile-nav__item a {
	/* con este combinator aumentamos la especificidad por lo tanto sobreescribimos los 
	estilos por defecto del navegador */
	text-decoration: none;
	color: var(--dark-green);
	font-weight: bold;
	/* padding: 3px 0; */
	padding: 0.2rem 0;
}

/* este pseudelemento after nos ayuda a renderizar contenido despues de cada coincidencia
que haya del selector, en este caso lo agregará despues de cada etiqueta a dentro de selector main-nav__item
en content irá el texto que se agregará y los estilos que se agreguen despues serán los estilos de ese contenido
*/
.main-nav__item a::after {
	content: ' (Link)';
	color: red;
}

/* ya no necesitamos este selector al usar flexbox, era para seleccionar el div que contiene
nuestra imagen y nuestro menu hamburguesa, como ya están centrados gracias al flexbox
esto ya no es necesario */
/* .main-header > div {
	display: inline-block;
	usando vertical align asignamos el texto a estar verticalmente centrado 
	con respecto a su padre, para que textos de diferentes contenedores esten alineados 
	verticalmente debemos agregar la misma propiedad a todos estos
	vertical-align: middle;
} */

.main-header__brand {
	color: #0e4f1f;
	/* sobreescribimos el text-decoration-underline que es
	default del navegador con el none para que quite el subrayado */
	text-decoration: none;
	/* asignamos el tipo de letra a negrita */
	font-weight: bold;
	/* font-size: 22px; */
	/* font-size: 1.5rem; */
	/* height: 2.5rem; */

	/* agregar un height aqui no tendría efecto en la imagen que es hija del contenedor
	en css las imagenes siempre por defecto se muestran de tamaño completo si no se asigna directamente un atributo de height */
	/*podriamos agregar un display inline block aqui para poder asignar un tamaño al contenedor
	ya que la etiqueta a es de tipo inline 
	esto es una nota importante, cualquier imagen dentro de un elemento inline hará que al usar porcentajes en esa imagen
	no se respete al contenedor padre*/
	/* esto lo soluciona porque con inline-block podemos jugar con el alto de los elementos */
	/* height: 22px; */
	/* eliminamos la altura fija para que la altura sea dinámica según tengamos o no nuestro menú hamburguesa */
	/* height: 1.5rem; */
	/* eliminamos el display inlineblock
	por lo tanto ya no podemos asignar una altura a este elemento porque es de tipo block,
	por lo tanto la altura a signar deberá ser directamente en la imagen que está dentro
	de este contenedor */

	/* display: inline-block;
	vertical-align: middle; */
}

.main-header__brand img {
	/* agregar aqui un height haria que tome el 100% del tamaño de la imagen, no de la del contenedor
	agregar un valor fijo en una medida como pixeles sí funcionaría pero no es laúnica forma*/
	/*valores porcentuales en etiquetas img no nos ayudan porque no respetan
	el tamaño del contenedor del elemento*/
	/* modificamos el tamaño de la imagen de nuestro nav para que
	la altura del nav se ajuste en base a esta imagen y no del menu hamburguesa */
	/* height: 2.5rem; */
	/* asignamos la altura directamente a la imagen
	ya que no podemos asignar a su contenedor porque es de tipo block */
	height: 2.5rem;
	/* height: 100%; */
	/* alineamos nuestra imagen verticalmente para que este en línea con el
	boton hamburguesa que tambien esta alineado verticalmente y al tener los 2 elementos diferentes alturas y márgenes
	es la opción más sencilla de centrarlos a ambos */
	vertical-align: middle;
}

.main-nav {
	/* nuestro nav no se mostrará en moviles ya que para moviles 
	tenemos el menú especifico para móviles donde estarán los botones que no caben
	en el navbar para ello solo lo ocultamos y como estará oculto no necesitamos
	ningún estilo por loq ue eliminamos los estilos*/
	display: none;
	/* display: inline-block; */
	/* lo de abajo no alinea el texto a la derecha aunque las etiquetas a son tomadas como texto
	porque se esta tomando el elemento como display inlineblock, por lo tanto no toma todo el ancho
	*/
	/* este width hace que tome todo el ancho y como no cabe todo el contenido se pasa a una nueva linea */
	/* width: calc(100% - 44px);
	text-align: right;
	vertical-align: middle; */
}

.main-nav__items {
	/* margin: 0;
	padding: 0; */
	/* agregamos estos estilos a los items de nuestro nav
	y con esto sobreescribimos los estilos que se asignan por defecto
	al mismo, y con esto logramos quitar los paddings y margins ya que
	los asigna el navegador y no nosotros */
	margin: 0;
	padding: 0;
	/* eliminamos los bullet points aunque el padding 0 ya los elimina */
	list-style: none;
	/* hacemos nuestro contenedor flex para poder usar flexbox
	y tener nuestros botones de main distribuidos horizontalmente */
	display: flex;
}

/* pseudoelementos agregan estilos en base al estado de elementos */

/* podemos agregar esta agrupación con comas, así seleccioanmos las dos pseudoclases
y agregamos los estilos a ambas para no tenerlas por separado y para cambiar los colores en ambas
al mismo tiempo de ser necesario */
.main-nav__item a:hover,
.main-nav__item a:active {
	color: white;
	border-bottom: 5px solid white;
}

/* para agregar animaciones a nuestros elementos, nos posicionamos directamente sobre el selector del elemento
que queremos animar, y usamos el atributo animation, este recibe varios paramétros */
.main-nav__item---cta {
	/* el primer atributo de animation es el nombre de la animación que vamos a usar, en este caso
	usaremos la animación de nombre wiggle, el segundo atributo es la duración de la animación, en este caso 200 milisegundos
	como tercer atributo tenemos el delay que tendrá nuestra animación, aquí estamos asignando un delay de 3 segundos,
	tenemos despues otro atributo que es el conteo de iteraciones que es cuantas veces se va a repetir la animación,
	en este caso le indicamos que la animación se va a repetir 8 veces, el siguiente parámetro indica la
	dirección en que se ejecutará la acción, en este caso le estamos indicando que la animación se alternará, es decir
	una vez que termine, se ejecutará en orden inverso, y luego nuevamente en el orden inicial, cabe denotar que esta rebobinación cuenta
	como una iteración por tanto si ponemos 8 como conteo de iteraciones, nuestra animación pareciera ejecutarse solo 4 veces
	pero es porque en realidad sí se ejecuta las 8 veces pero cada vez que se rebobina también se cuenta como una iteración*/
	/* animation: wiggle 200ms 3s 8 alternate; */
	/* podemos usar envez de alternate la palabra reverse, y esto ejecutará la animación empezando siempre por el keyframe final
	y hacia el inicio, haciendo un salto al finalizar, de nuevo al frame final y de nuevo hacia el inicio y así sucesivamente
	es decir invierte los keyframes, tenemos también la opción alternate-reverse, que hace los keyframes al revés y además los rebobina
	y vuelve a ejecutarlos  */
	/* animation: wiggle 200ms 3s 8 reverse; */
	/* además de la dirección de la animación también tenemos el fill-mode, este atributo define como se rellenarán los estilos del elemento
	cuando no se este ejecutando ninguna animación en él */
	/* por ejemplo el valor forwards hace que cuando la animación terminé, el elemento conserve el estilo del último keyframe
	(y será el último keyframe considerando que se puede invertir la dirección de la animación y el conteo de iteraciones)
	 */
	/* animation: wiggle 200ms 3s 8 forwards; */
	/* por otra parte, el valor backwards hará que antes de que se ejecute la animación (es decir el tiempo que dure el delay),
	 el elemento que se anima, ya tenga definidos los estilos del valor del primer keyframe */
	/* animation: wiggle 200ms 3s 8 backwards; */
	/* y el valor por defecto es none, donde no se rellena con estilos el elemento el tiempo que dure con delay, ni se agregan estilos
	para cuando la animación del elemento termina */
	animation: wiggle 200ms 3s 8 none;
}

/* pseudoelementos agregan estilos dentro del contenido de elementos */
/* p::first-letter {
	color: red;
	font-size: 20px;
} */

.main-nav__item---cta a,
.mobile-nav__item--cta a {
	color: white;
	background: var(--highlight-color);
	/* padding: 8px 16px; */
	padding: 0.5rem 1rem;
	border-radius: 8px;
}

.main-nav__item---cta a:hover,
.main-nav__item---cta a:active,
.mobile-nav__item---cta a:hover,
.mobile-nav__item---cta a:active {
	color: var(--highlight-color);
	background: white;
	border: none;
}

.main-footer {
	background-color: black;
	/* padding: 32px; */
	padding: 2rem;
	/* margin-top: 48px; */
	margin-top: 3rem;
	/* grid-row:3 / 4; */
	/* asignamos nuestro footer a la template area de footer, puede ser asignando los rows pero
	nos es más facil hacerlo de este modo ya que ya tenemos las áreas definidas */
	grid-area: footer;
}

.main-footer__links {
	list-style: none;
	margin: 0;
	padding: 0;
	/* eliminamos text-align porque nuestros
	elementos ya no serán de tipo block */
	/* text-align: center; */
	/* usamos flex y centramos como columna nuestros elementos verticalmente */
	display: flex;
	flex-direction: column;
	align-items: center;
}

.main-footer__link {
	/* para moviles nuestro footer tendrá sus elementos como bloques
	para que ocupen todo el ancho y se muestren uno encima de otro */
	/* display: block; */
	/* margin: 0 16px; */
	/* tambien como estaran apilados necesitamos margenes verticales */
	/* reducimos el espacio de nuestro elementos que estaran apilados
	porque el margin collapsing no funciona en elementos flex */
	margin: 0.5rem 0;
}

.main-footer__link a {
	color: white;
	/* con text decoration eliminamos el subrayado */
	text-decoration: none;
}

.main-footer__link a:hover,
.main-footer__link a:active {
	color: #ccc;
}

/* se agregan estilos de sidebar para móviles */
.mobile-nav {
	/* display: none; */
	/* vamos a ocultar y mostrar este menú con el uso de transiciones, para ocultarlo,
	moveremos en el eje X de forma negativa usando un valor porcentual, y este valor porcentual
	hace referencia al elemento mismo, por lo que aquí al usar -100% lo que queremos indicar esque
	nuestro elemento se desplazará de forma horizontal 100% hacia la izquierda, o dicho de otro modo
	saldrá completamente del viewport hacia la izquierda, tambien estamos agregando una transición al elemento para 
	cuando se modifique su propiedad transform, se agregué una transición de 300 milisegundos
	con una función de tiempo. Cuando se active la clase open, el transform de esa clase .open va a sobreescribir
	este translateX, aunque allá no estemos declarando especificamente un translateX(0) que lo reestableceríá a su posición original
	al elemento, sino un translateY(0), el hecho de que usemos un transform hace que las demas propiedades del transform 
	se sobreescriban, por tanto el elemento con la clase .open volverá a su posición inicial que es mostrándose en pantalal
	 y es como si sí se estuviera declarando el translateX(0)*/
	transform: translateX(-100%);
	transition: transform 300ms ease-out;

	position: fixed;
	z-index: 101;
	top: 0;
	left: 0;
	background: white;
	width: 80%;
	height: 100vh;
}

.mobile-nav__items {
	width: 90%;
	height: 100%;
	list-style: none;
	/* eliminamos el margen superior porque ahora flexbox 
	nos ayudará a posicionar los elementos de la forma vertical*/
	margin: 0 auto;
	padding: 0;
	/* ya no necesitamos text-align porque
	nuestro elemento ya no será de tipo block */
	/* text-align: center; */

	/* creamos nuestro elemento flex para alinear verticalmente y al centro
	y en forma de columna nuestro menú lateral */
	display: flex;
	flex-direction: column;
	justify-content: center;
	align-items: center;
}

.mobile-nav__item {
	margin: 1rem 0;
}

.mobile-nav__item a {
	font-size: 1.5rem;
}

/* se agregan estilos de boton de menú hamburguesa */
.toggle-button {
	width: 3rem;
	background: transparent;
	border: none;
	cursor: pointer;
	padding-top: 0;
	padding-bottom: 0;
	vertical-align: middle;
}

.toggle-button:focus {
	outline: none;
}

.toggle-button__bar {
	width: 100%;
	height: 0.2rem;
	background: black;
	display: block;
	margin: 0.6rem 0;
}
/*  creamos la clase open que se agregará y removerá dinámicamente de nuestro dom
para mostrar y ocultar elementos, aquí estamos agregando la clase important, porque en el orden
de importación de nuestros archivos css, este archivo shared está antes de main, entonces lo que está en main
está sobreescribiendo los estilos de shared, porque tienen la misma especificidad, entonces aqui se usa el orden
de delcaración donde el main va despues, con important anulamos esa sobreescritura y hacemos que aunque 
main tenga mas especificidad los estilos que escribamos aquí no sean borrados  */
.open {
	display: block !important;
	/* ya que agregamos la opacidad 0 inicial al elemento, debemos agregar que cuando se agregue la clase open
	esa opacidad pase de 0 a 1, por tanto envez de estar oculto el elemento lo va a mostrar, 
	tambien agregamos un translate, porque inicialmente abremos transladado nuestro elemento en el eje Y fuera de la pantalla usando
	un translate negativo, aquí lo que haremos sera regresarlo a la posición original dentro de la pantalla */
	/* ademas aplicamos important para que este elemento no se sobreescriba por otros elementos ya que hay una clase con mayor
	nivel de especificidad que sobreescribiría estos elementos si no hubieramos agregado el !important */
	opacity: 1 !important;
	transform: translateY(0) !important;
}

/* añadimos nuestros querys para corregir nuestro navbar y footer */
@media (min-width: 40rem) {
	/* el toggle no debería verse en resoluciones altas así que lo ocultamos */
	.toggle-button {
		display: none;
	}

	/* la barra de navegación deberia contener nuestro nav 
	con nuestras rutas a las otras páginas, por lo tanto la mostramos
	usando inline-block, y el ancho lo hacemos del 100% menos el balor de nuestra imagen
	del nav, además de alinearlo verticalmente al centro y como texto a la derecha, nuestra lista
	al alinear como texto mueve todos nuestros elementos ya que lo tenemos como inline block*/

	.main-nav {
		/* display: inline-block;
		width: calc(100% - 44px);
		text-align: right;
		vertical-align: middle; */
		/* agregamos display block para que nuestro nav se muestre, como el nav por defecto es de tipo block
		no se verá alguna otra modificación
		 */
		display: block;
	}
	/* en nuestro footer igualmente mostramos nuestros elementos en inline
	y agregamos margen hacia los lados de nuestro elemento ya que en resoluciones altas
	se mostrarán uno al lado del otro */
	.main-footer__link {
		/* nuestros elementos ya no serán de tipo block, entonces
		eliminamos esto, el margen pasa ahora de ser margen vertical
		a margen horizontal porque nuestros elementos estarán uno al lado del otro  */
		/* display: inline-block; */

		/* margin: 0 16px; */
		margin: 0 1rem;
	}

	.main-footer__links {
		/* agregamos solo los atributos que se van a modificar
esta clase ya tiene la direction como column así que la modificamos para que sea un row
nuestro contenido ya está con align-items center, así que nos falta aplicar el mismo atributo a justify-content
para que tenga ambas alineaciones  */
		flex-direction: row;
		/* align-items: center; */
		justify-content: center;
	}
}

/* para crear nuestra animación debemos definir la serie de keyframes que tendrá,
los keyframes son los estados o pasos que tendrá la animación desde su posición inicial hasta su posición final, pudiendo 
tener pasos intermedios, para definir el paso inicial o el 0% de la animación podemos usar
la palabra resevada from y entre llaves indicar la animación inicial que queremos que tenga, pueden ser varios atributos iniciales,
después en la propiedad to (que equivale al final o al 100% de la animación), definimos el estado final que tendrá nuestro 
elemento al cual aplicaremos la animación */
@keyframes wiggle {
	from {
		/* transform: rotateZ(0); */
		transform: rotateZ(-10deg);
		/* podemos animar muchas propiedades aunque algunas de ellas no son transicionables y el cambio de un
		valor a otro se ve reflejado inmediatamente y no gradualmente durante el tiempo que dura la animación */
		/* color: ;
		background: ; */
	}
	to {
		transform: rotateZ(10deg);
	}
}
